 
#include "shell.h"

extern struct list_command list_cmd[MAX_CMD];
extern unsigned int built_in_cmd_count;

int main()
{
    unsigned char command[20];
    unsigned int i;
    void (*run_cmd)();

    init_command();
    while (1) {
	run_cmd = NULL;
	printf("%s", SHELL_PROMPT);
	uart_gets(command, 20);
	if (strlen(command) == 0)
	    continue;
	
	for (i=0; i<built_in_cmd_count; i++) {
	    if (strcmp(command, list_cmd[i].command) == 0) {
		run_cmd = list_cmd[i].cmd_function;
		break;
	    }
	}

	if (run_cmd == NULL) {
	    printf("%s: command not found\n\n", command);

	    /* 명령어를 모르니까 도와준다 */
	    cmd_help();
	    
	    continue;
	} else {
	    run_cmd();
	}
    }

    /*
     * 이 태스크는 종료되서는 안된다.
     * 만약 이곳까지 왔다는건 엄청난 버그다. ㅎ
     */
    while (1)
	;
    
    return 0;
}
