
#ifndef _SHELL_H
#define _SHELL_H

#include "syscall.h"
#include "printf.h"
#include "string.h"
#include "system.h"

#define SHELL_PROMPT	"BlueOS:/$ "
#define MAX_CMD		10

struct list_command 
{
    unsigned char command[10];
    void (*cmd_function)();
};

void init_command();
void cmd_help();
void cmd_version();
void cmd_getdate();
void cmd_setdate();
void cmd_ps();
void cmd_clear();

#endif
